---
title: SourceBuffer.appendBufferAsync()
slug: Web/API/SourceBuffer/appendBufferAsync
tags:
  - API
  - Audio
  - Experimental
  - MSE
  - Media
  - Media Source Extensions
  - Method
  - Non-standard
  - Reference
  - SourceBuffer
  - Video
  - appendBufferAsync
---
<div>{{APIRef("Media Source Extensions")}}{{non-standard_header}}{{SeeCompatTable}}</div>

<p><span class="seoSummary">The <code><strong>appendBufferAsync()</strong></code> method of the {{domxref("SourceBuffer")}} interface begins the process of asynchronously appending media segment data from an {{jsxref("ArrayBuffer")}} or {{domxref("ArrayBufferView")}} object to the <code>SourceBuffer</code>.</span> It returns a {{jsxref("Promise")}} which is fulfilled once the buffer has been appended.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>appendPromise</em> = <em>sourceBuffer</em>.appendBufferAsync(<em>source</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>source</code></dt>
 <dd>A {{domxref("BufferSource")}} (that is, either an {{domxref("ArrayBufferView")}} or {{jsxref("ArrayBuffer")}}) which contains the media segment data you want to add to the <code>SourceBuffer</code>.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("Promise")}} which is fulfilled when the buffer has been added successfully to the <code>SourceBuffer</code>, or <code>null</code> if the request could not be initiated.</p>

<h2 id="Example">Example</h2>

<p>This simplified example async function, <code>fillSourceBuffer()</code>, takes as input parameters {{domxref("BufferSource")}}, <code>buffer</code>, and a <code>SourceBuffer</code> to which to append the source media from the buffer.</p>

<pre class="brush: js">async function fillSourceBuffer(buffer, msBuffer) {
  try {
    while(true) {
      await msBuffer.appendBufferAsync(buffer);
    }
  } catch(e) {
    handleException(e);
  }
}
</pre>

<h2 id="Specifications">Specifications</h2>

<p>Not currently part of any specification. This is being experimented with under the auspices of the <strong>Web Platform Incubator Community Group</strong> (WICG).</p>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Media Source Extensions')}}</td>
   <td>{{Spec2('Media Source Extensions')}}</td>
   <td>Initial definition; does not include this method.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.SourceBuffer.appendBufferAsync")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Media_Source_Extensions_API">Media Source Extensions API</a></li>
 <li>{{domxref("SourceBuffer.appendBuffer()")}}</li>
 <li>{{domxref("MediaSource")}}</li>
 <li>{{domxref("SourceBufferList")}}</li>
</ul>
